<template>
    <div class="relative">
        <div @click="open = !open">
            <slot name="trigger" />
        </div>
        <div
            v-show="open"
            class="fixed inset-0 z-40"
            @click="open = false"
        ></div>
        <transition
            enter-active-class="transition ease-out duration-200"
            enter-from-class="transform opacity-0 scale-95"
            enter-to-class="transform opacity-100 scale-100"
            leave-active-class="transition ease-in duration-75"
            leave-from-class="transform opacity-100 scale-100"
            leave-to-class="transform opacity-0 scale-95"
        >
            <div
                v-show="open"
                :class="[widthClass, alignmentClasses]"
                class="absolute z-50 mt-2 rounded-md shadow-lg"
                style="display: none"
                @click="open = false"
            >
                <div
                    :class="contentClasses"
                    class="rounded-md ring-1 ring-black ring-opacity-5"
                >
                    <slot name="content" />
                </div>
            </div>
        </transition>
    </div>
</template>

<script setup>
import { computed, defineProps, onMounted, onUnmounted, ref } from "vue";

const props = defineProps({
    align: {
        default: "right",
    },
    width: {
        default: "48",
    },
    contentClasses: {
        default: () => ["py-1", "bg-white"],
    },
});
onMounted(() => document.addEventListener("keydown", closeOnEscape));
onUnmounted(() => document.removeEventListener("keydown", closeOnEscape));
const open = ref(false);
const closeOnEscape = (e) => {
    if (open.value && e.key === "Escape") {
        open.value = false;
    }
};
const widthClass = computed(() => {
    return {
        48: "w-48",
    }[props.width.toString()];
});
const alignmentClasses = computed(() => {
    if (props.align === "left") {
        return "origin-top-left left-0";
    } else if (props.align === "right") {
        return "origin-top-right right-0";
    } else {
        return "origin-top";
    }
});
</script>
